#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>


#define BUFSIZE 512

int
get_daytime (char* serveur, char* resultat)
{
  int sock;
  struct servent* service;
  struct sockaddr_in serv_addr;
  struct hostent* host;
  int res;
  
  service = getservbyname ("daytime", "tcp");
  if (service == NULL)
    {
      perror ("getservbyname");
      return -1;
    }

  host = gethostbyname (serveur);
  if (host == NULL)
    {
      herror ("gethostbyname");
      errno = 0;
      return -1;
    }
  
  memset (&serv_addr, 0, sizeof (serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_port   = service->s_port;
  serv_addr.sin_addr   = *((struct in_addr*)host->h_addr);

  /* On a toutes les donnes ncessaires. On peut crer la socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock == -1)
    {
      perror ("socket");
      return -1;
    }

  /* La socket est cre. On peut la connecter  l'adresse/port prcis */
  res = connect (sock, (struct sockaddr*) &serv_addr, sizeof (serv_addr));
  if (res == -1)
    {
      perror ("connect");
      return -1;
    }
  
  /* La socket est connecte. On peut y lire des donnes. */  
  res = read (sock, resultat, BUFSIZE - 1);
  if (res == -1)
    {
      perror ("read");
      return -1;
    }
  else
    {
      /* On ferme la socket */
      close (sock);

      /* On termine la chane */
      resultat[res + 1] = 0;
      return res;
    }
}

int
main (int argc, char* argv[])
{
  char *daytime;
  int r;

  if (argc != 2)
    {
      fprintf (stderr, "Syntaxe : %s nom-machine\n", argv[0]);
      exit (1);
    }

  daytime = (char*) malloc (BUFSIZE);
  if (daytime == NULL)
  {
    perror ("Erreur d'allocation de mmoire ");
    exit (1);
  }

  r = get_daytime (argv[1], daytime);
  if (r == -1)
    {
      perror ("Erreur lors de la connexion ");
      exit (1);
    }

  printf ("La date de l'ordinateur %s est %s", argv[1], daytime);
  exit (0);
}


